module.exports = function(config) {
	config.set({
		basePath : '..',
		plugins : ['karma-requirejs',
		           'karma-coverage',
		           'karma-phantomjs-launcher',
		           'karma-jasmine-ajax',
		           'karma-jasmine',
		           'karma-jshint',
		           'karma-mocha-reporter',
		           'karma-junit-reporter'
		           ],
		frameworks : [ 'jasmine-ajax', 'jasmine', 'requirejs' ],
		files : [ {
			pattern : 'es5-ff-spa-loader.js',
			included : false
		}, {
			pattern : 'test/spec/**/*.js',
			included : false
		}, 'test/spec-runner.js' ],
		browsers : [ 'PhantomJS' ],
		preprocessors : {
			'es5-ff-spa-loader.js' : [ 'jshint', 'coverage' ],
			'example/**/*.js' : [ 'jshint' ],
			'test/**/*.js' : [ 'jshint' ]
		},
		reporters : [ 'coverage', 'mocha', 'junit' ],
		coverageReporter : {
			dir : 'test/report',
			reporters : [ {
				type : 'lcov',
				subdir : '.'
			} ]
		},
		junitReporter : {
			outputDir : 'test/report',
			outputFile : 'TEST-karma.xml',
			useBrowserName : false,
		},
		jshint : {
			options : {
				strict : true,
				browser : true,
				jasmine : true,
				predef : [ 'define' ]
			},
			summary : true
		}
	});
};