
define(['es5-ff-spa-loader'], function(FFSpaLoader) {
	'use strict';
	
	describe('Start loader', function() {
		beforeEach(function () {
			function emptyElement(element) {
				var myNode = element;
				while (myNode.firstChild) {
					myNode.removeChild(myNode.firstChild);
				}
			}
			emptyElement(document.head);
			emptyElement(document.body);
		});
		it('FFSpaLoader start with error', function(done) {
			FFSpaLoader.options.server.url = 'http://localhost:9999';
			FFSpaLoader.start(function(err) {
				if (err !== null) {
					done();
				} else {
					fail();
				}
			});
		});
		it('FFSpaLoader starts', function(done) {
			FFSpaLoader.options.server.url = 'http://localhost:9090/test';
			FFSpaLoader.options.server.assets = '/static/spa-client-resources';
			FFSpaLoader.start(function(err) {
				if (err !== null) {
					fail();
				} else {
					done();
				}
			});
		});
		it('FFSpaLoader starts again', function(done) {
			FFSpaLoader.options.server.url = 'http://localhost:9090/test';
			FFSpaLoader.options.server.assets = '/static/spa-client-resources';
			FFSpaLoader.start(function(err) {
				if (err !== null) {
					fail();
				} else {
					done();
				}
			});
		});	
	});
});
